"use strict";
function collectDataFromConstructor(vm, Component) {
    Component.prototype._init = function () {
        var _this = this;
        Object.getOwnPropertyNames(vm).forEach(function (key) {
            Object.defineProperty(_this, key, {
                get: function () { return vm[key]; },
                set: function (value) { return vm[key] = value; }
            });
        });
    };
    var data = new Component();
    var plainData = {};
    Object.keys(data).forEach(function (key) {
        if (data[key] !== undefined) {
            plainData[key] = data[key];
        }
    });
    return plainData;
}
exports.collectDataFromConstructor = collectDataFromConstructor;
